clear; clc; close all;

numNN = 5;
scale = 2;
pSize = 5;
gradThresh = 20;

%% construct dictionaries
numP = 1000;
format = 'png';
imgPath = '.\Train';

[dictH, dictL] = collectPatch(imgPath, gradThresh, format, scale, pSize, numP);

%% learning
para.startA = 1.0e+1;
para.stepSize = 1.0e-2;
para.maxIter = 5000;
para.epsilon = 1.0e-8;
para.numBatch = 1;
numM = 50;

[M, C, idxM] = trainLLKR(dictH, dictL, numM, numNN, para);

%% super resolution
mFactor = 2;
gradThresh = 0;
testName = '0000';
testPath = ['.\Test\' testName '.png'];
testImg = imread(testPath);
overlap = pSize - 1;

[imgH] = LLKR(testImg, dictH, dictL, M, C, idxM, overlap, mFactor, gradThresh, numNN);

imwrite(imgH, ['.\' testName 'x' num2str(mFactor) '.png'], 'png');
